//
// Compensate for recent Windows header files and lack of d3dkmthk.h
//

// SEE: https://github.com/jingoro2112/dna/blob/master/dnausb/win32/ddk/api/d3dkmthk.h

#define _In_
#define _Out_
#define _Out_Opt_
#define _InOut_

typedef HANDLE HMONITOR;

#define DISPLAY_DEVICE_ACTIVE 0x1

#define GET_Y_LPARAM(lp) ((int)(short)HIWORD(lp))
#define GET_X_LPARAM(lp) ((int)(short)LOWORD(lp))

typedef struct tagMONITORINFOEX {
    DWORD cbSize;
    RECT  rcMonitor;
    RECT  rcWork;
    DWORD dwFlags;
    TCHAR szDevice[CCHDEVICENAME];
    } MONITORINFOEX, *LPMONITORINFOEX;
#define MONITOR_DEFAULTTONEAREST 0x2
#define MONITORINFOF_PRIMARY 0x1

typedef LONG NTSTATUS;
#define STATUS_SUCCESS  ((NTSTATUS)0x00000000L)
#define STATUS_NOT_IMPLEMENTED ((NTSTATUS)0xC0000002L)

typedef enum _KMTQUERYADAPTERINFOTYPE {
    KMTQAITYPE_UMDRIVERPRIVATE         =  0,
    KMTQAITYPE_UMDRIVERNAME            =  1,
    KMTQAITYPE_UMOPENGLINFO            =  2,
    KMTQAITYPE_GETSEGMENTSIZE          =  3,
    KMTQAITYPE_ADAPTERGUID             =  4,
    KMTQAITYPE_FLIPQUEUEINFO           =  5,
    KMTQAITYPE_ADAPTERADDRESS          =  6,
    KMTQAITYPE_SETWORKINGSETINFO       =  7,
    KMTQAITYPE_ADAPTERREGISTRYINFO     =  8,
    KMTQAITYPE_CURRENTDISPLAYMODE      =  9,
    KMTQAITYPE_MODELIST                = 10,
    KMTQAITYPE_CHECKDRIVERUPDATESTATUS = 11,
    KMTQAITYPE_VIRTUALADDRESSINFO      = 12, // _ADVSCH_
    KMTQAITYPE_DRIVERVERSION           = 13,
    } KMTQUERYADAPTERINFOTYPE;
typedef enum _D3DDDI_ROTATION { 
    D3DDDI_ROTATION_IDENTITY  = 1,
    D3DDDI_ROTATION_90        = 2,
    D3DDDI_ROTATION_180       = 3,
    D3DDDI_ROTATION_270       = 4
    } D3DDDI_ROTATION;
typedef enum _D3DDDIFORMAT { 
    D3DDDIFMT_UNKNOWN                  = 0,
    } D3DDDIFORMAT;

typedef UINT D3DKMT_HANDLE;
typedef UINT D3DDDI_VIDEO_PRESENT_SOURCE_ID;
typedef struct _D3DKMT_OPENADAPTERFROMHDC {
    HDC                             hDc;            // in:  DC that maps to a single display
    D3DKMT_HANDLE                   hAdapter;       // out: adapter handle
    LUID                            AdapterLuid;    // out: adapter LUID
    D3DDDI_VIDEO_PRESENT_SOURCE_ID  VidPnSourceId;  // out: VidPN source ID for that particular display
    } D3DKMT_OPENADAPTERFROMHDC;
typedef struct _D3DKMT_CLOSEADAPTER {
    D3DKMT_HANDLE hAdapter;
    } D3DKMT_CLOSEADAPTER;
typedef struct _D3DKMT_WAITFORVERTICALBLANKEVENT {
    D3DKMT_HANDLE                   hAdapter;      // in: adapter handle
    D3DKMT_HANDLE                   hDevice;       // in: device handle [Optional]
    D3DDDI_VIDEO_PRESENT_SOURCE_ID  VidPnSourceId; // in: adapter's VidPN Source ID
    } D3DKMT_WAITFORVERTICALBLANKEVENT;
typedef struct _D3DKMT_GETSCANLINE {
    D3DKMT_HANDLE                  hAdapter;
    D3DDDI_VIDEO_PRESENT_SOURCE_ID VidPnSourceId;
    BOOLEAN                        InVerticalBlank;
    UINT                           ScanLine;
    } D3DKMT_GETSCANLINE;
typedef struct _D3DKMT_QUERYADAPTERINFO {
    D3DKMT_HANDLE           hAdapter;
    KMTQUERYADAPTERINFOTYPE Type;
    VOID                    *pPrivateDriverData;
    UINT                    PrivateDriverDataSize;
    } D3DKMT_QUERYADAPTERINFO;

typedef enum _D3DDDI_VIDEO_SIGNAL_SCANLINE_ORDERING { 
    D3DDDI_VSSLO_UNINITIALIZED               = 0,
    D3DDDI_VSSLO_PROGRESSIVE                 = 1,
    D3DDDI_VSSLO_INTERLACED_UPPERFIELDFIRST  = 2,
    D3DDDI_VSSLO_INTERLACED_LOWERFIELDFIRST  = 3,
    D3DDDI_VSSLO_OTHER                       = 255
    } D3DDDI_VIDEO_SIGNAL_SCANLINE_ORDERING;
typedef struct _D3DDDI_RATIONAL {
    UINT Numerator;
    UINT Denominator;
    } D3DDDI_RATIONAL;

typedef enum _D3DKMDT_MODE_PRUNING_REASON { 
    D3DKMDT_MPR_UNINITIALIZED                                = 0,
    D3DKMDT_MPR_ALLCAPS                                      = 1,
    D3DKMDT_MPR_DESCRIPTOR_MONITOR_SOURCE_MODE               = 2,
    D3DKMDT_MPR_DESCRIPTOR_MONITOR_FREQUENCY_RANGE           = 3,
    D3DKMDT_MPR_DESCRIPTOR_OVERRIDE_MONITOR_SOURCE_MODE      = 4,
    D3DKMDT_MPR_DESCRIPTOR_OVERRIDE_MONITOR_FREQUENCY_RANGE  = 5,
    D3DKMDT_MPR_DEFAULT_PROFILE_MONITOR_SOURCE_MODE          = 6,
    D3DKMDT_MPR_DRIVER_RECOMMENDED_MONITOR_SOURCE_MODE       = 7,
    D3DKMDT_MPR_MONITOR_FREQUENCY_RANGE_OVERRIDE             = 8,
    D3DKMDT_MPR_CLONE_PATH_PRUNED                            = 9,
    D3DKMDT_MPR_MAXVALID                                     = 10
    } D3DKMDT_MODE_PRUNING_REASON;

typedef struct _D3DKMDT_DISPLAYMODE_FLAGS {
    BOOLEAN                     ValidatedAgainstMonitorCaps  :1;
    BOOLEAN                     RoundedFakeMode  :1;
    D3DKMDT_MODE_PRUNING_REASON ModePruningReason  :4;
    UINT                        Reserved  :28;
    } D3DKMDT_DISPLAYMODE_FLAGS;

typedef struct _D3DKMT_DISPLAYMODE {
    UINT                                   Width;
    UINT                                   Height;
    D3DDDIFORMAT                           Format;
    UINT                                   IntegerRefreshRate;
    D3DDDI_RATIONAL                        RefreshRate;
    D3DDDI_VIDEO_SIGNAL_SCANLINE_ORDERING  ScanLineOrdering;
    D3DDDI_ROTATION                        DisplayOrientation;
    UINT                                   DisplayFixedOutput;
    D3DKMDT_DISPLAYMODE_FLAGS              Flags;
    } D3DKMT_DISPLAYMODE;

typedef struct _D3DKMT_CURRENTDISPLAYMODE {
    D3DDDI_VIDEO_PRESENT_SOURCE_ID VidPnSourceId; /*in*/
    D3DKMT_DISPLAYMODE             DisplayMode;   /*out*/
    } D3DKMT_CURRENTDISPLAYMODE;



typedef NTSTATUS (APIENTRY *LPFND3DKMT_OPENADAPTERFROMHDC)(D3DKMT_OPENADAPTERFROMHDC*);
typedef NTSTATUS (APIENTRY *LPFND3DKMT_CLOSEADAPTER)(D3DKMT_CLOSEADAPTER*);
typedef NTSTATUS (APIENTRY *LPFND3DKMT_WAITFORVERTICALBLANKEVENT)(D3DKMT_WAITFORVERTICALBLANKEVENT*);
typedef NTSTATUS (APIENTRY *LPFND3DKMT_GETSCANLINE)(D3DKMT_GETSCANLINE*);
typedef NTSTATUS (APIENTRY *LPFND3DKMT_QUERYADAPTERINFO)(D3DKMT_QUERYADAPTERINFO *);


#pragma pack(push)
#pragma pack(4)

//----------------------------------------------------------------------
// https://msdn.microsoft.com/en-us/library/windows/desktop/aa969503(v=vs.85).aspx
//typedef struct _DWM_TIMING_INFO {
//  UINT32          cbSize;              // 0:1
//  UNSIGNED_RATIO  rateRefresh;         // 1:2
//  QPC_TIME        qpcRefreshPeriod;    // 3:2 *** offset 3
//  UNSIGNED_RATIO  rateCompose;         // 5:2
//  QPC_TIME        qpcVBlank;           // 7:2 *** offset 7
//   qpc2tick(*(LARGE_INTEGER*)(aTI+7));    // qpcVBlank
//   *(OSTICK*)(aTI+3);                    // qpcRefreshPeriod

typedef ULONGLONG DWM_FRAME_COUNT;
typedef ULONGLONG QPC_TIME;

typedef struct _UNSIGNED_RATIO {
    UINT32 uiNumerator;
    UINT32 uiDenominator;
    } UNSIGNED_RATIO;

typedef struct _DWM_TIMING_INFO {
    UINT32 cbSize;
    UNSIGNED_RATIO rateRefresh;
    QPC_TIME qpcRefreshPeriod;
    UNSIGNED_RATIO rateCompose;
    QPC_TIME qpcVBlank;
    DWM_FRAME_COUNT cRefresh;
    UINT cDXRefresh;
    QPC_TIME qpcCompose;
    DWM_FRAME_COUNT cFrame;
    UINT cDXPresent;
    DWM_FRAME_COUNT cRefreshFrame;
    DWM_FRAME_COUNT cFrameSubmitted;
    UINT cDXPresentSubmitted;
    DWM_FRAME_COUNT cFrameConfirmed;
    UINT cDXPresentConfirmed;
    DWM_FRAME_COUNT cRefreshConfirmed;
    UINT cDXRefreshConfirmed;
    DWM_FRAME_COUNT cFramesLate;
    UINT cFramesOutstanding;
    DWM_FRAME_COUNT cFrameDisplayed;
    QPC_TIME qpcFrameDisplayed;
    DWM_FRAME_COUNT cRefreshFrameDisplayed;
    DWM_FRAME_COUNT cFrameComplete;
    QPC_TIME qpcFrameComplete;
    DWM_FRAME_COUNT cFramePending;
    QPC_TIME qpcFramePending;
    DWM_FRAME_COUNT cFramesDisplayed;
    DWM_FRAME_COUNT cFramesComplete;
    DWM_FRAME_COUNT cFramesPending;
    DWM_FRAME_COUNT cFramesAvailable;
    DWM_FRAME_COUNT cFramesDropped;
    DWM_FRAME_COUNT cFramesMissed;
    DWM_FRAME_COUNT cRefreshNextDisplayed;
    DWM_FRAME_COUNT cRefreshNextPresented;
    DWM_FRAME_COUNT cRefreshesDisplayed;
    DWM_FRAME_COUNT cRefreshesPresented;
    DWM_FRAME_COUNT cRefreshStarted;
    ULONGLONG cPixelsReceived;
    ULONGLONG cPixelsDrawn;
    DWM_FRAME_COUNT cBuffersEmpty;
    } DWM_TIMING_INFO;
#pragma pack(pop)

